Subject: Re: [Gen-art] Gen-ART Last Call review of draft-ietf-ippm-2679-bis-03

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Sun, 2 Aug 2015 14:45:28 -0400

Hi Brian,

Thanks for your review. 
Please see replies and proposed resolutions below.

regards,
Al

> -----Original Message-----
> From: Brian E Carpenter [mailto:[email-masked]]
> Sent: Friday, July 31, 2015 3:45 AM
> To: [email-masked]; General Area Review Team
> Subject: Gen-ART Last Call review of draft-ietf-ippm-2679-bis-03
> 
> I am the assigned Gen-ART reviewer for this draft. For background on
> Gen-ART, please see the FAQ at
> <http://wiki.tools.ietf.org/area/gen/trac/wiki/GenArtfaq>.
> 
> Please resolve these comments along with any other Last Call comments
> you may receive.
> 
> Document: draft-ietf-ippm-2679-bis-03.txt
> Reviewer: Brian Carpenter
> Review Date: 2015-07-31
> IETF LC End Date: 2015-08-11
> IESG Telechat date:
> 
> Summary: Ready with issues
> --------
> 
> Major issue:
> ------------
> 
> The draft does not mention the IP version.  RFC 2330 states that it
> applies to IPv4 only (section 15) and uses terminology that only applies
> to IPv4. At the very minimum, the current draft needs to state its
> limited applicability. I would be much happier if it explained how it
> applies to IPv6.
[ACM]
In this update, we added an explicit reference to Section 15 of RFC 2330
on the requirements for standard-formed packets (note: most, but not all, 
usage of "standard-formed" in RFC2330 is hyphenated). I suggest that we
note the limitation of the current reference in the text:

+ The packet is standard-formed, the default criteria for all metric 
  definitions defined in Section 15 of [RFC2330], otherwise the packet 
  will be deemed lost. Note: At this time, the definition of standard-formed
  packets only applies to IPv4.

Further, I propose that we begin the process of updating this section of 
RFC 2330 immediately. This way, the IPv6 coverage will extend to all
IPPM RFCs, especially RFC2680bis which is also in IETF Last Call.

> 
> Minor issues:
> -------------
> 
> In sections 3.6 and 3.8.1 there are passing references to the diffserv
> code point. I think that the ECN bits should be mentioned too: their
> setting could also affect router processing time. ECN is a bit tricky as
> it might change on the fly.

[ACM]
So can DSCP if the packet is re-marked, as you know well.
We can mention ECN in section 3.8.1 (the original text referred to the 
TOS field, so what you read was already updated), with further revisions below:

The value of Type-P-One-way-Delay could change if the protocol (UDP or TCP), 
port number, size, or arrangement for special treatment (e.g., IP DS Field 
[RFC2780], ECN [RFC3168] or RSVP) changes. The exact Type-P used to make 
the measurements MUST be accurately reported.

But...

> 
> Along the same lines, should Router Alert be mentioned? And for IPv6
> applicability, any hop-by-hop options should certainly be mentioned.

[ACM]
RFC 2330, Section 13 says:
   A fundamental property of many Internet metrics is that the value of
   the metric depends on the type of IP packet(s) used to make the
   measurement.
   ... < some IPv4-centric examples, then > ...
   Because of this distinction, we introduce the generic notion of a
   "packet of type P", where in some contexts P will be explicitly
   defined (i.e., exactly what type of packet we mean), partially
   defined (e.g., "with a payload of B octets"), or left generic.

If we seek to identify several more distinctions for "packets of Type-P",
then I would prefer to update the RFC 2330 Framework Section 13 on
this topic, so it's more widely applicable and less IPv4-centric.
I'll take immediate steps to accomplish this update.

---

From: Brian E Carpenter <[email-masked]>
Date: Mon, 03 Aug 2015 18:52:54 +1200

Hi Al,

On 03/08/2015 06:45, MORTON, ALFRED C (AL) wrote:

<big snip>

> I'll take immediate steps to accomplish this update.

Yes, I think that is much more constructive than trying to do it
piecemeal in the 2679bis draft. Perhaps you can contrive to plant
a "forward reference" to 2330bis here, by saying that future extensions
of the "packets of Type-P" definition will apply. That would take
care of all my issues in one go.

   Brian

---

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Mon, 3 Aug 2015 09:51:45 -0400

Hi Brian,

> Sent: Monday, August 03, 2015 2:53 AM
> To: MORTON, ALFRED C (AL); [email-masked];
> General Area Review Team
> Subject: Re: Gen-ART Last Call review of draft-ietf-ippm-2679-bis-03
> 
> Hi Al,
> 
> > If we seek to identify several more distinctions for "packets of
> > Type-P", then I would prefer to update the RFC 2330 Framework Section
> > 13 on this topic, so it's more widely applicable and less IPv4-
> centric.
> piecemeal in the 2679bis draft. Perhaps you can contrive to plant a
> "forward reference" to 2330bis here, by saying that future extensions of
> the "packets of Type-P" definition will apply. That would take care of
> all my issues in one go.
> 
>    Brian
[ACM] 
Thank you, consider it done. I will make equivalent revisions in RFC2680bis.

regards,
Al

---

From: Guy Almes <[email-masked]>
Date: Mon, 3 Aug 2015 09:02:29 -0500

Al,
   I very much agree on moving toward treating IPv6 fully as these evolve.
	-- Guy

---

From: Spencer Dawkins at IETF <[email-masked]>
Date: Mon, 3 Aug 2015 11:31:24 -0500

And, for what it's worth, the responsible AD agrees with what Brian and Al
are cooking up, for this draft and for RFC2680bis.

Spencer

---

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Thu, 6 Aug 2015 13:55:07 -0400

Hi Brian,
CC: Fred Baker,
see below...

> > 13 on this topic, so it's more widely applicable and less IPv4-centric.

[ACM] 
Besides planting the forward reference,
I assembled a knowledgeable author team and we produced
a first draft update to RFC 2330 in the areas of Type-P and
standard-formed packets. Thanks for your early suggestions 
on the text.  

Also, thanks to Fred Baker who helped us 
understand some of the IPv6 complexities.

The 00 text is here:
https://tools.ietf.org/html/draft-morton-ippm-2330-stdform-typep-00

Comments welcome,
Al
(for the co-authors)

---

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Fri, 7 Aug 2015 08:10:54 -0400

FYI - the official announcement below, please note points for discussion:

A New Internet-Draft is available from the on-line Internet-Drafts directories.

        Title           : Updates for IPPM's Active Metric Framework: 
                          Packets of Type-P and Standard-Formed Packets
        Authors         : Al Morton
                          Joachim Fabini
                          Nalini Elkins
                          Michael S. Ackermann
                          Vinayak Hegde
	Filename        : draft-morton-ippm-2330-stdform-typep-00.txt
	Pages           : 10
	Date            : 2015-08-06

Abstract:
   This memo updates the IP Performance Metrics (IPPM) Framework RFC
   2330 with new considerations for measurement methodology and testing.
   The memo updates the definition of standard-formed packets in RFC
   2330 to include IPv6 packets.  It also augments distinguishing
   aspects of packets, referred to as Type-P for test packets in RFC
   2330.

   Two points (at least) are worthwhile discussing further: extent of
   coverage for 6LO and IPv6 Header Compression, and the continued need
   to define a "minimal standard-formed packet".

The IETF datatracker status page for this draft is:
https://datatracker.ietf.org/doc/draft-morton-ippm-2330-stdform-typep/

There's also a htmlized version available at:
https://tools.ietf.org/html/draft-morton-ippm-2330-stdform-typep-00

> From: MORTON, ALFRED C (AL)
> Sent: Thursday, August 06, 2015 1:55 PM
> To: 'Brian E Carpenter'; [email-masked]; General
> Area Review Team
> Cc: Fred Baker (fred) ([email-masked])
> Subject: RE: Gen-ART Last Call review of draft-ietf-ippm-2679-bis-03
> 
> Hi Brian,
> CC: Fred Baker,
> see below...
> 
> > "forward reference" to 2330bis here, by saying that future extensions
> > of the "packets of Type-P" definition will apply. That would take care
> > of all my issues in one go.
> >
> >    Brian
> 
> [ACM]
> I assembled a knowledgeable author team and we produced a first draft
> update to RFC 2330 in the areas of Type-P and standard-formed packets.
> Thanks for your early suggestions on the text.
> 
> Also, thanks to Fred Baker who helped us understand some of the IPv6
> complexities.
> 
> The 00 text is here:

---

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Fri, 7 Aug 2015 09:18:04 -0400

(adding ippm-list, .all alias for the draft does not seem to include it)

Abstract:

---

From: "MORTON, ALFRED C (AL)" <[email-masked]>
Date: Fri, 7 Aug 2015 11:47:42 -0400

Re-sending to include IPPM-list (not in .all alias)
to give the full context:

> Sent: Sunday, August 02, 2015 2:45 PM
> > applies to IPv4 only (section 15) and uses terminology that only
> > applies to IPv4. At the very minimum, the current draft needs to state
> > its limited applicability. I would be much happier if it explained how
> > it applies to IPv6.
> [ACM]
> on the requirements for standard-formed packets (note: most, but not
> all, usage of "standard-formed" in RFC2330 is hyphenated). I suggest
> that we note the limitation of the current reference in the text:
>

---

From: Jari Arkko <[email-masked]>
Date: Thu, 20 Aug 2015 15:58:58 +0300

Thanks for the review, Brian, and thanks for addressing the issues and starting another effort to address IPv6.

Jari